package sav.example.javaz;
import sav.z.*;

import java.io.*;
/**
 * This example is typical use of basic Session, Variable and Base
 * classes.
 */
public class IntroductionDemo {
  public static void main(String arg[]) throws IOException {
    String userData =
      "$base 'users';" +
      "$readTable() <" +
        "User  ; Name   ; Resource  \n" +
        "ann   ; Anna   ; data1     \n" +
        "dan   ; Daniel ; data2     \n" +
        "rob   ; Robert ; data3     \n" +
      ">;"
    ;
    String ownerData =
      "$base 'owners';" +
      "$readTable() <" +
        "Owner  ; Name    \n" +
        "ann    ; Anna    \n" +
        "rob    ; Robert  \n" +
      ">;"
    ;
    Session ss0 = new Session();
    ss0.z(userData); //creates Users database
    ss0.z(ownerData); //creates Owners database
    ss0.close();
    
    String script =
      "$print(OWNER USERS - first variant);\n" +
      "= $base 'owners';\n" +
      "$x = Owner/;\n" +
      "= $base 'users';\n" +
      "$print(User/$x);";
    ;
    Session ss = new Session();
    Printer prt = new WPrinter(new PrintWriter(System.out));
    ss.setReportPrinter(prt);
    ss.z(script);
    prt.flush();
    
    System.out.println("OWNER USERS - second variant");
    ss.exploreBase("owners");
    ss.z("$x = Owner/;");
    Variable owners = ss.var("x");
    ss.closeBase();
    Base users = ss.exploreBase("users");
    for (String owner = owners.first(); owner != null; owner = owners.next()) {
      if (users.has("User", owner))
        System.out.println(owner);
    }
    owners.clear();
    ss.closeBase();
  }
}
